import {__rest}from'tslib';import {FormControl,FormLabel}from'@chakra-ui/form-control';import {Input}from'@chakra-ui/input';import {Box,VStack,Divider,Flex,SimpleGrid,Spacer,Link}from'@chakra-ui/layout';import {useToast,chakra,IconButton,Slider,SliderTrack,SliderFilledTrack,SliderThumb,NumberInput,NumberInputField,Button,Switch}from'@chakra-ui/react';import {Select}from'@chakra-ui/select';import {Textarea}from'@chakra-ui/textarea';import React__default from'react';import {FaMinus,FaPlus}from'react-icons/fa';import {useQuery,useMutation}from'react-query';import {Link as Link$1}from'react-router-dom';import {fetchCities,fetchPropertyTypes,postRoom,postImage,deleteImage}from'../API.js';const getUniqeCountries = (res) => {
    let countries = [];
    let indexes = new Set();
    for (let i of res) {
        if (!indexes.has(i.countryId)) {
            countries.push({ id: i.countryId, countryName: i.countryName });
        }
        indexes.add(i.countryId);
    }
    console.log(countries);
    return countries;
};
const PublishRoomPage = (_a) => {
    var props = __rest(_a, []);
    const toast = useToast();
    const [countries, setCountries] = React__default.useState();
    const [room, setRoom] = React__default.useState({
        cityId: "1",
        countryId: "",
        description: "Test description",
        images: [
            {
                url: "https://picsum.photos/1100/1000?random=1",
                alt: "alt",
                deleteHash: "delHash"
            },
            {
                url: "https://picsum.photos/1100/1000?random=2",
                alt: "alt",
                deleteHash: "delHash"
            },
            {
                url: "https://picsum.photos/1100/1000?random=3",
                alt: "alt",
                deleteHash: "delHash"
            }
        ],
        maxGuest: 0,
        propTypeId: "",
        introdution: "Lorem ipsum dolor sit amet consectetur adipisicing elit. Architecto minus ad assumenda dignissimos. Perferendis optio est nam accusamus aliquid voluptas?",
        name: "Lorem ipsum",
        refundPercent: 100,
        number: "12",
        streetName: "Street asdfgg",
        services: {
            breakfast: true,
            kitchen: false,
            parking: true,
            pet: false,
            wifi: true
        },
        basePrice: 250,
        cleaningFee: 10,
        serviceFee: 0
    });
    React__default.useEffect(() => { console.log(room.cityId); }, [room]);
    const { data: resCities, isLoading, status } = useQuery("cities", fetchCities, {
        staleTime: 1000 * 60 * 10,
        onSuccess: (res) => {
            console.log(res);
            setCountries(getUniqeCountries(res));
        }
    });
    const { data: resTypes, isError } = useQuery("propertypeList", fetchPropertyTypes, {
        staleTime: 1000 * 60 * 10
    });
    const publish = useMutation(postRoom, {
        onSuccess: (res) => {
            toast({ description: res.data, status: "success" });
        },
        onError: (err) => {
            console.log(err);
            toast({ description: "Something's wrong", status: "error" });
        },
    });
    const handlePublish = (e) => {
        e.preventDefault();
        publish.mutate(room);
    };
    React__default.useEffect(() => {
        return function cleanup() { localStorage.removeItem("previewRoom"); };
    }, []);
    const handleImagesInput = (e) => {
        if (e.target.files != null) {
            const files = Array.from(e.target.files);
            const formData = new FormData();
            formData.append("image", files[0]);
            postImage(formData).then((msg) => msg.data).catch(e => console.log(e));
            deleteImage("").then(msg => console.log(msg.data));
        }
    };
    return (React__default.createElement(chakra.form, null,
        React__default.createElement(Box, Object.assign({ d: 'flex', flexDir: "column", mt: "10" }, props),
            React__default.createElement(VStack, { spacing: "8", w: "75%", alignSelf: "center" },
                React__default.createElement(Box, { as: "h1", fontSize: "3xl", fontWeight: "bold", alignSelf: "start" }, "Publish your new property"),
                React__default.createElement(Divider, { borderColor: "currentcolor" }),
                React__default.createElement(Box, { d: { base: "inline-block", lg: "flex" }, flexDir: "row", w: "100%", fontWeight: "medium" },
                    React__default.createElement(Box, { as: "h2", fontSize: "lg", w: { base: "100%", lg: "30%" }, mb: "5" }, "Property info"),
                    React__default.createElement(VStack, { alignItems: "start", w: "100%" },
                        React__default.createElement(FormControl, { isRequired: true, id: "prop-name" },
                            React__default.createElement(FormLabel, { as: "h2", fontSize: "md" }, "Property Name"),
                            React__default.createElement(Input, { variant: "filled", required: true, value: room.name, onChange: (e) => setRoom(r => (Object.assign(Object.assign({}, r), { name: e.target.value }))) })),
                        React__default.createElement(FormControl, { isRequired: true, id: "prop-type" },
                            React__default.createElement(FormLabel, { as: "h2", fontSize: "md" }, "Property's Type"),
                            React__default.createElement(Select, { variant: "filled", placeholder: "--Choose your property type--", onChange: (e) => setRoom((r) => (Object.assign(Object.assign({}, r), { propTypeId: e.target.value, cityId: "" }))) }, resTypes === null || resTypes === void 0 ? void 0 : resTypes.map(rt => {
                                return React__default.createElement("option", { value: rt.id, key: rt.id }, rt.propertyType);
                            }))),
                        React__default.createElement(FormControl, { isRequired: true, id: "prop-description" },
                            React__default.createElement(FormLabel, { as: "h2", fontSize: "md" }, "Description"),
                            React__default.createElement(Input, { variant: "filled", required: true, value: room.description, onChange: (e) => setRoom((r) => (Object.assign(Object.assign({}, r), { description: e.target.value }))) })),
                        React__default.createElement(FormControl, { isRequired: true, id: "prop-introduction" },
                            React__default.createElement(FormLabel, { as: "h2", fontSize: "md" }, "Introduction"),
                            React__default.createElement(Textarea, { rows: 4, required: true, variant: "filled", value: room.introdution, onChange: (e) => setRoom((r) => (Object.assign(Object.assign({}, r), { introdution: e.target.value }))) })))),
                React__default.createElement(Divider, { borderColor: "currentcolor" }),
                React__default.createElement(Box, { d: { base: "inline-block", lg: "flex" }, flexDir: "row", w: "100%", fontWeight: "medium" },
                    React__default.createElement(Box, { as: "h2", fontSize: "lg", w: { base: "100%", lg: "30%" }, mb: "5" }, "Location info"),
                    React__default.createElement(VStack, { alignItems: "start", w: "100%" },
                        React__default.createElement(FormControl, { isRequired: true, id: "prop-country" },
                            React__default.createElement(FormLabel, { as: "h2", fontSize: "md" }, "Country"),
                            React__default.createElement(Select, { variant: "filled", placeholder: "--Choose your country--", onChange: (e) => setRoom((r) => (Object.assign(Object.assign({}, r), { countryId: e.target.value, cityId: "" }))) }, countries === null || countries === void 0 ? void 0 : countries.map(c => {
                                return React__default.createElement("option", { value: c.id, key: c.countryName }, c.countryName);
                            }))),
                        React__default.createElement(FormControl, { isRequired: true, id: "prop-city" },
                            React__default.createElement(FormLabel, { as: "h2", fontSize: "md" }, "City"),
                            React__default.createElement(Select, { variant: "filled", placeholder: "--Choose your city--", onChange: (e) => {
                                    setRoom((r) => (Object.assign(Object.assign({}, r), { cityId: e.target.value })));
                                } }, resCities === null || resCities === void 0 ? void 0 : resCities.filter(ct => ct.countryId === room.countryId).map(c => {
                                return React__default.createElement("option", { value: c.id, key: c.id }, c.cityName);
                            }))),
                        React__default.createElement(Flex, { gridGap: "2", w: "100%", flexDir: { base: 'column', lg: "row" } },
                            React__default.createElement(FormControl, { isRequired: true, id: "prop-street", flex: "0 1 60%" },
                                React__default.createElement(FormLabel, { as: "h2", fontSize: "md" }, "Street Name"),
                                React__default.createElement(Input, { required: true, variant: "filled", value: room.streetName, onChange: (e) => { setRoom((r) => (Object.assign(Object.assign({}, r), { streetName: e.target.value }))); } })),
                            React__default.createElement(FormControl, { isRequired: true, id: "prop-number", flex: "0 1 40%" },
                                React__default.createElement(FormLabel, { as: "h2", fontSize: "md" }, "Property's number"),
                                React__default.createElement(Input, { required: true, variant: "filled", value: room.number, onChange: (e) => { setRoom((r) => (Object.assign(Object.assign({}, r), { number: e.target.value }))); } }))),
                        React__default.createElement(FormControl, { id: "prop-add-note" },
                            React__default.createElement(FormLabel, { as: "h2", fontSize: "md" },
                                "Notes to client",
                                React__default.createElement(Box, { as: "span", fontStyle: "oblique", fontWeight: "light" }, "(optional)")),
                            React__default.createElement(Input, { variant: "filled", value: room.addressDesc, onChange: (e) => { setRoom((r) => (Object.assign(Object.assign({}, r), { addressDesc: e.target.value }))); } })))),
                React__default.createElement(Divider, { borderColor: "currentcolor" }),
                React__default.createElement(Box, { d: { base: "inline-block", lg: "flex" }, flexDir: "row", w: "100%", fontWeight: "medium", justifyContent: "space-between" },
                    React__default.createElement(Box, { as: "h2", fontSize: "lg", w: { base: "100%", lg: "30%" }, mb: "5", flexWrap: "wrap" },
                        React__default.createElement(Box, null, "Images"),
                        React__default.createElement(Box, { as: "span", fontStyle: "oblique", fontWeight: "light" }, " (At least 5 images)")),
                    React__default.createElement(Input, { required: true, variant: "ghost", type: "file", justifySelf: "flex-end", multiple: true, accept: "image/*", onChange: (e) => handleImagesInput(e) })),
                React__default.createElement(Divider, { borderColor: "currentcolor" }),
                React__default.createElement(Box, { d: { base: "inline-block", lg: "flex" }, flexDir: "row", w: "100%", fontWeight: "medium" },
                    React__default.createElement(Box, { as: "h2", fontSize: "lg", w: { base: "100%", lg: "30%" }, mb: "5" }, "Services"),
                    React__default.createElement(Box, { w: "100%" },
                        React__default.createElement(SimpleGrid, { minChildWidth: "12em", spacingX: "5rem", spacingY: "2" },
                            React__default.createElement(Flex, { gridGap: "2", alignItems: "center" },
                                React__default.createElement(Box, { as: "h2", fontSize: "md" }, "Max Guests"),
                                React__default.createElement(Spacer, null),
                                React__default.createElement(IconButton, { "aria-label": "Minus", size: "sm", icon: React__default.createElement(FaMinus, null), isDisabled: room.maxGuest <= 0, onClick: () => setRoom((r) => (Object.assign(Object.assign({}, r), { maxGuest: r.maxGuest-- }))) }),
                                React__default.createElement(Box, { as: "h3", fontSize: "md", w: "3ch", textAlign: "center" }, room.maxGuest),
                                React__default.createElement(IconButton, { "aria-label": "Plus", size: "sm", icon: React__default.createElement(FaPlus, null), isDisabled: room.maxGuest >= 10, onClick: () => setRoom((r) => (Object.assign(Object.assign({}, r), { maxGuest: r.maxGuest++ }))) })),
                            React__default.createElement(ServiceDisplay, { name: "Wifi", isOn: room.services.wifi, toggle: (checked) => { setRoom((r) => (Object.assign(Object.assign({}, r), { services: (Object.assign(Object.assign({}, r.services), { wifi: checked })) }))); } }),
                            React__default.createElement(ServiceDisplay, { name: "Kitchen", isOn: room.services.kitchen, toggle: (checked) => { setRoom((r) => (Object.assign(Object.assign({}, r), { services: (Object.assign(Object.assign({}, r.services), { kitchen: checked })) }))); } }),
                            React__default.createElement(ServiceDisplay, { name: "Breakfast", isOn: room.services.breakfast, toggle: (checked) => { setRoom((r) => (Object.assign(Object.assign({}, r), { services: (Object.assign(Object.assign({}, r.services), { breakfast: checked })) }))); } }),
                            React__default.createElement(ServiceDisplay, { name: "Pet Allow", isOn: room.services.pet, toggle: (checked) => { setRoom((r) => (Object.assign(Object.assign({}, r), { services: (Object.assign(Object.assign({}, r.services), { pet: checked })) }))); } }),
                            React__default.createElement(ServiceDisplay, { name: "Free Parking", isOn: room.services.parking, toggle: (checked) => { setRoom((r) => (Object.assign(Object.assign({}, r), { services: (Object.assign(Object.assign({}, r.services), { parking: checked })) }))); } })))),
                React__default.createElement(Divider, { borderColor: "currentcolor" }),
                React__default.createElement(Box, { d: { base: "inline-block", lg: "flex" }, flexDir: "row", w: "100%", fontWeight: "medium" },
                    React__default.createElement(Box, { as: "h2", fontSize: "lg", w: { base: "100%", lg: "30%" }, mb: "5" }, "Pricing ($)"),
                    React__default.createElement(VStack, { alignItems: "start", w: "100%" },
                        React__default.createElement(ServiceDisplay, { isOn: room.refundPercent === 100 ? true : false, name: "Allow full refund", size: "lg", toggle: (checked) => { setRoom((r) => (Object.assign(Object.assign({}, r), { refundPercent: checked ? 100 : 80 }))); } }),
                        room.refundPercent !== 100 &&
                            React__default.createElement(Box, null,
                                "Amount refund: ",
                                room.refundPercent,
                                "%"),
                        React__default.createElement(Slider, { value: room.refundPercent, min: 0, max: 100, step: 5, colorScheme: "blue", onChange: (percent) => { setRoom((r) => (Object.assign(Object.assign({}, r), { refundPercent: percent }))); } },
                            React__default.createElement(SliderTrack, null,
                                React__default.createElement(SliderFilledTrack, null)),
                            React__default.createElement(SliderThumb, { boxSize: 6 })),
                        React__default.createElement(FormControl, { isRequired: true, id: "prop-price-base", isInvalid: room.basePrice === 0 ? true : false },
                            React__default.createElement(FormLabel, { opacity: room.basePrice === 0 ? 0.4 : 1, as: "h2", fontSize: "md" }, "Base price"),
                            React__default.createElement(NumberInput, { value: room.basePrice, onChange: (price) => { setRoom((r) => (Object.assign(Object.assign({}, r), { basePrice: parseInt(price) | 0 }))); } },
                                React__default.createElement(NumberInputField, { variant: "filled", required: true }))),
                        React__default.createElement(FormControl, { isRequired: true, id: "prop-price-cleaning" },
                            React__default.createElement(FormLabel, { opacity: room.cleaningFee === 0 ? 0.4 : 1, as: "h2", fontSize: "md" }, "Cleaning fee"),
                            React__default.createElement(NumberInput, { value: room.cleaningFee, onChange: (price) => { setRoom((r) => (Object.assign(Object.assign({}, r), { cleaningFee: parseInt(price) | 0 }))); } },
                                React__default.createElement(NumberInputField, { variant: "filled", required: true }))),
                        React__default.createElement(FormControl, { isRequired: true, id: "prop-price-service" },
                            React__default.createElement(FormLabel, { opacity: room.serviceFee === 0 ? 0.4 : 1, as: "h2", fontSize: "md" }, "Service fee"),
                            React__default.createElement(NumberInput, { value: room.serviceFee, onChange: (price) => { setRoom((r) => (Object.assign(Object.assign({}, r), { serviceFee: parseInt(price) | 0 }))); } },
                                React__default.createElement(NumberInputField, { variant: "filled", required: true }))))),
                React__default.createElement(Box, null,
                    React__default.createElement(Link, { as: Link$1, to: "/room/preview", _hover: { textStyle: "none" }, target: "_blank", onClick: () => localStorage.setItem("previewRoom", JSON.stringify(room)) },
                        React__default.createElement(Button, { variant: "solid", mr: "10", colorScheme: "green" }, "See a preview")),
                    React__default.createElement(Button, { variant: "solid", type: "submit", colorScheme: "blue", onClick: (e) => handlePublish(e) }, "Confirm"))))));
};
const ServiceDisplay = (props) => React__default.createElement(FormControl, { display: "flex", alignItems: "center", justifyContent: "space-between", pr: "2" },
    React__default.createElement(FormLabel, { htmlFor: "service_" + props.name, mb: "0", opacity: props.isOn ? 1 : 0.4 }, props.name),
    React__default.createElement(Switch, Object.assign({ id: "service_" + props.name, isChecked: props.isOn }, props, { onChange: (e) => { props.toggle(e.target.checked); } })));export default PublishRoomPage;//# sourceMappingURL=PublishRoomPage.js.map
