import {useToast,Box,Divider,Spacer,Button,Grid,GridItem,Image,Flex,VStack,HStack,Avatar}from'@chakra-ui/react';import React__default from'react';import {BsStarFill,BsStar,BsHeart,BsHeartFill}from'react-icons/bs';import {useQuery,useMutation}from'react-query';import {useParams,Link}from'react-router-dom';import {fetchPropertyById,toggleLike}from'../API.js';import PickRangeDay from'../components/NavComponents/PickRangeDay.js';import FloatingForm from'../components/ReservationForm.js';import MyRoomBadge,{defaultRoomBadges}from'../components/SingleRoomComponents/MyRoomBadge.js';import {AuthContext}from'../Contexts/AuthContext.js';const SingleRoom = ({ initRoom, children }) => {
    var _a;
    const auth = React__default.useContext(AuthContext);
    const [room, setRoom] = React__default.useState(defaultRoom);
    const [bookInfo, setBookInfo] = React__default.useState({ guest: 0, children: 0 });
    const [owner, setOwner] = React__default.useState();
    const [didLike, setDidLike] = React__default.useState(false);
    const { slug } = useParams();
    const toast = useToast();
    const { data, isError, error, isLoading } = useQuery(["property", slug], () => {
        return fetchPropertyById(slug);
    }, {
        // staleTime: 1000 * 60 * 3,
        retry: 2,
        onError: (error) => {
            console.log(error);
        },
        onSuccess: (rs) => {
            if (rs.data.liked)
                setDidLike(rs.data.liked);
            setRoom(Object.assign(Object.assign({}, rs.data), { roomBadges: badges }));
            setBookInfo(bi => (Object.assign(Object.assign({}, bi), { roomId: rs.data.id })));
        },
        onSettled: () => {
        }
    });
    const mutateLike = useMutation(toggleLike, {
        onSuccess: (res) => {
            setDidLike(res.data.liked);
            toast({
                description: res.data.liked ? "Saved room" : "Removed from wishlist",
                status: "info",
                duration: 1000
            });
        },
        onError: (error) => console.log(error)
    });
    React__default.useEffect(() => {
        setOwner(defaultOwner);
    }, []);
    const updateDate = (from, to) => {
        setBookInfo(s => (Object.assign(Object.assign({}, s), { bookFromDate: from, bookToDate: to })));
    };
    const updatePeople = (adult, children) => {
        setBookInfo((s) => (Object.assign(Object.assign({}, s), { guest: adult, children: children })));
    };
    const handleLike = () => {
        if (!auth.user) {
            toast({
                description: "Login is required",
                status: "info",
                duration: 1000
            });
            return;
        }
        mutateLike.mutate({ roomId: room.id, token: auth.user.token });
    };
    // if (isError) {
    //     return <Box>{"Something 's wrong"}</Box>
    // }
    if (data)
        return (React__default.createElement(Box, null,
            React__default.createElement(Divider, { my: "5" }),
            React__default.createElement(Box, { as: "h2", fontSize: "3xl", fontWeight: "semibold" }, room.name),
            React__default.createElement(Box, { d: "flex", mt: "1", flexDir: { base: "column", sm: "row" } },
                React__default.createElement(Box, { d: "flex", alignItems: "start" },
                    React__default.createElement(Box, { d: "flex", flexDir: { base: "column", sm: "row" } },
                        React__default.createElement(Box, { d: "flex", flexDir: { base: "row" } }, Array(5).fill("").map((_, i) => {
                            return (i < Math.round(room.totalStar / room.totalReview) ? React__default.createElement(BsStarFill, { key: i, colorRendering: "teal.400" }) : React__default.createElement(BsStar, { key: i }));
                        })),
                        React__default.createElement(Box, { as: "span", ml: "2", color: "gray.500" },
                            room.totalReview,
                            " reviews")),
                    React__default.createElement(Spacer, null),
                    React__default.createElement(Link, { to: "/" },
                        React__default.createElement(Button, { variant: "link" },
                            React__default.createElement(Box, { mx: "4" }, "\u2022"),
                            room.location))),
                React__default.createElement(Spacer, null),
                React__default.createElement(Button, { alignSelf: "start", variant: "ghost", size: "sm", onClick: () => handleLike(), leftIcon: (!didLike || !auth.user) ? React__default.createElement(BsHeart, null) : React__default.createElement(BsHeartFill, { color: "red" }) }, "Like")),
            React__default.createElement(Box, { borderRadius: "lg", overflow: "hidden", mt: "4" },
                React__default.createElement(Grid, { gap: "2", h: "40%", maxH: "450px", objectFit: "cover", templateRows: "repeat(2, 1fr)", templateColumns: "repeat(4, 1fr)" }, room.images.slice(0, 5).map((image, i) => {
                    return (React__default.createElement(GridItem, { key: i, colSpan: i === 0 ? 2 : 1, rowSpan: i === 0 ? 2 : 1, overflow: "hidden" },
                        React__default.createElement(Image, { src: image.url, h: "auto", height: "100%", w: "100%", objectFit: "cover", loading: "lazy" })));
                }))),
            React__default.createElement(Box, { mt: "4", d: ["flex", "flex", "flex", "block"], flexDir: "column-reverse" },
                React__default.createElement(Box, { w: ["100%", "100%", "100%", "35%"], boxShadow: "2xl", mt: { base: "4", lg: "0" }, top: "30%", float: { lg: "right" }, position: { lg: "sticky" }, borderRadius: "lg", display: "inline-flex", flexDir: "column", zIndex: 1, borderWidth: "thin", p: "4", alignContent: "center", justifyContent: "center" },
                    React__default.createElement(FloatingForm, { room: room, bookInfo: bookInfo, updateDate: updateDate, updatePeople: updatePeople })),
                React__default.createElement(Box, { height: "1000px", w: ["100%", "100%", "100%", "60%"] },
                    React__default.createElement(Flex, { alignItems: "center" },
                        React__default.createElement(VStack, { alignItems: "start" },
                            React__default.createElement(Box, { as: "h1", fontSize: "2xl", fontWeight: "semibold" }, "Owner: " + (owner === null || owner === void 0 ? void 0 : owner.name)),
                            React__default.createElement(HStack, null, room.services.map((s, i) => {
                                return (React__default.createElement(Box, { key: i, color: "gray.500", fontWeight: "semibold", letterSpacing: "wide", fontSize: "xs", textTransform: "uppercase", ml: "2", isTruncated: true },
                                    s,
                                    " ",
                                    room.services[room.services.length - 1] !== s && React__default.createElement(React__default.Fragment, null, "\u2022"),
                                    " "));
                            }))),
                        React__default.createElement(Spacer, null),
                        React__default.createElement(Avatar, { name: owner === null || owner === void 0 ? void 0 : owner.name, src: owner === null || owner === void 0 ? void 0 : owner.profileImageUrl })),
                    React__default.createElement(Divider, { my: "3" }), (_a = room.roomBadges) === null || _a === void 0 ? void 0 :
                    _a.map((b, i) => {
                        return React__default.createElement(MyRoomBadge, { id: b.id, key: i });
                    }),
                    React__default.createElement(Divider, { my: "3" }),
                    React__default.createElement(Box, { as: "h5", fontWeight: "semibold", fontSize: "2xl" }, "More about room"),
                    React__default.createElement(Box, { as: "p" }, room.introduction),
                    React__default.createElement(Divider, { my: "3" }),
                    React__default.createElement(Box, { w: "100%", display: { md: "none", lg: "block" } },
                        React__default.createElement(PickRangeDay, { schedules: { reservedDates: room.reservedDates, dayOff: room.daysOff }, updateDate: updateDate })),
                    React__default.createElement(Divider, { my: "3" })))));
    return React__default.createElement(React__default.Fragment, null);
};
const badges = defaultRoomBadges;
const defaultRoom = {
    id: "1",
    name: "Crystal palace",
    thumbnailUrl: "https://bit.ly/2Z4KKcF",
    maxGuest: 1,
    images: [
        { url: "https://picsum.photos/1100/1000" },
        { url: "https://picsum.photos/700/1200" },
        { url: "https://picsum.photos/1000/1000" },
        { url: "https://picsum.photos/1200/1000" },
        { url: "https://picsum.photos/1100/900" }
    ],
    thumbnailAlt: "rear view house with pool",
    introduction: "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum congue eros id ligula porta, id fermentum ligula semper. Pellentesque eget pulvinar justo. Phasellus eu risus dolor. Aliquam mollis urna vel lectus ornare, nec ultricies augue gravida. Nunc dignissim diam vel massa cursus condimentum. Nulla pharetra molestie nunc, ac hendrerit felis posuere a. Sed finibus magna ut nibh luctus, ac dapibus mauris cursus. Sed eu porttitor lacus. Nulla venenatis erat quis orci consectetur efficitur. Phasellus nisl nisl, luctus et sapien nec, dictum feugiat felis. Nam nec ullamcorper mi, eu vulputate justo. Nullam nibh ipsum, dictum at commodo nec, molestie et ipsum. Aliquam sit amet tincidunt augue, sit amet consectetur mi.",
    description: "Best place in town",
    location: "Dark side, the moon",
    totalReview: 4,
    totalStar: 19,
    formattedPrice: 2021.00,
    services: ["Pet", "Kitchen", "Breakfast", "Wifi"],
    roomBadges: badges,
    serviceFee: 0.00,
    cleaningFee: 40.00
};
const defaultOwner = {
    id: "1234",
    name: "Ivanov Ivan Ivanovich",
    profileImageUrl: "https://scontent-arn2-1.xx.fbcdn.net/v/t1.6435-9/168934405_1649568108574870_2922711241924143290_n.jpg?_nc_cat=103&ccb=1-3&_nc_sid=09cbfe&_nc_ohc=NE0y-9oTNT4AX_6yZvA&_nc_ht=scontent-arn2-1.xx&oh=4a47294ccdbae32c261080108427acd1&oe=6096A09B"
};export default SingleRoom;//# sourceMappingURL=SingleRoom.js.map
