import {useToast,Box,Flex,Button}from'@chakra-ui/react';import React__default from'react';import'react-day-picker';import'react-day-picker/lib/style.css';const getDatesBetween = (fromDate, toDate) => {
    const from = new Date(fromDate);
    const to = new Date(toDate);
    let datesBtw = [];
    let start = from;
    start.setDate(start.getDate() + 1);
    while (start.getDate() < to.getDate()) {
        datesBtw.push(new Date(start));
        start.setDate(start.getDate() + 1);
    }
    return datesBtw;
};
const getDisabledDates = (schedules) => {
    let disabledDates = [];
    if (schedules === null || schedules === void 0 ? void 0 : schedules.reservedDates) {
        for (let i = 0; i < schedules.reservedDates.length; i++) {
            disabledDates.push(...getDatesBetween(schedules.reservedDates[i].fromDate, schedules.reservedDates[i].toDate));
        }
    }
    if (schedules === null || schedules === void 0 ? void 0 : schedules.dayOff)
        disabledDates.push(...schedules.dayOff);
    return disabledDates;
};
const getDateCheckOutOnly = (schedules) => {
    var _a;
    return (_a = schedules === null || schedules === void 0 ? void 0 : schedules.reservedDates) === null || _a === void 0 ? void 0 : _a.map(r => new Date(r.fromDate));
};
const defaultDate = {
    from: undefined,
    to: undefined,
    enteredTo: undefined
};
const PickRangeDay = ({ from, to, updateDate, schedules }) => {
    useToast();
    const [state, setState] = React__default.useState({ from: from, to: to });
    const disabled = [
        {
            before: new Date(Date.now())
        },
        ...getDisabledDates(schedules),
    ];
    React__default.useState(disabled);
    React__default.useEffect(() => {
        if (state.from && state.to || (!state.from && !state.to)) {
            updateDate(state.from, state.to);
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [state.from, state.to]);
    const handleResetClick = () => {
        setState(defaultDate);
    };
    [state.from, { from: state.from, to: state.enteredTo }];
    ({
        start: state.from,
        end: state.enteredTo,
        checkoutOnly: getDateCheckOutOnly(schedules),
    });
    return (React__default.createElement(Box, { alignSelf: "stretch" },
        React__default.createElement(Flex, { alignItems: "stretch", flexDir: "column" }),
        React__default.createElement(Flex, { justifyContent: "center", alignItems: "center" },
            !state.from && !state.to && 'Please select the first day.',
            state.from && !state.to && 'Please select the last day.',
            state.from &&
                state.to &&
                `Selected from ${state.from.toLocaleDateString()} to
                ${state.to.toLocaleDateString()}`,
            ' ',
            state.from && state.to && (React__default.createElement(Button, { onClick: handleResetClick }, "Reset")))));
};export default PickRangeDay;export{getDatesBetween};//# sourceMappingURL=PickRangeDay.js.map
